Attribute VB_Name = "Module1"
Sub import_sim_data()

Dim simFile As String
Dim errorLogFile() As Variant
Dim textline As String
Dim Row As Integer
Dim Column As Integer
Dim step_counter As Integer
Dim lineCounter As Long
Dim numberOfSteps As Integer

simFile = "M:\Entertainment\HiFi\Valve stuff\Power Amps\Baby Huey\LTSpice\spice error log.txt"

'simFile = Application.GetOpenFilename()

'Populate array from error log file
Open simFile For Input As #1
Do Until EOF(1)
    ReDim Preserve errorLogFile(lineCounter)
    Line Input #1, errorLogFile(lineCounter)
    lineCounter = lineCounter + 1
Loop
Close #1

'Populate Volts Peak In Column 1 (convert to mV)
Row = 6
Column = 1
For i = 0 To lineCounter - 1
    If InStr(errorLogFile(i), ".step vin=") <> 0 Then
        numberOfSteps = numberOfSteps + 1
        Dim temp As String
        temp = errorLogFile(i)
        Cells(Row, Column) = 1000 * NumericOnly(temp)
        'Cells(Row, Column) = 1000 * Right(errorLogFile(i), Len(errorLogFile(i)) - 10)
        Row = Row + 1
    End If
Next i

'Populate THD Columns
Row = 6
Column = 5
For i = 0 To lineCounter - 1
    If InStr(errorLogFile(i), "Total Harmonic Distortion:") <> 0 Then
        Dim temp1 As String
        temp1 = Left(errorLogFile(i), InStr(errorLogFile(i), "(") - 1)
        Select Case Column
            Case 5
                'V1A Anode
                Cells(Row, Column) = Mid(errorLogFile(i), 28, InStr(errorLogFile(i), "(") - 28)
                Column = Column + 1
            Case 6
                'Q1 Source
                Cells(Row, Column) = Mid(errorLogFile(i), 28, InStr(errorLogFile(i), "(") - 28)
                Column = Column + 1
            Case 7
                'Load
                Cells(Row, Column) = Mid(errorLogFile(i), 28, InStr(errorLogFile(i), "(") - 28)
                Column = 5
                Row = Row + 1
        End Select
    End If
Next i

'Populate Volts Peak Out Column
Row = 6
Column = 2
For i = 0 To lineCounter - 1
    If InStr(errorLogFile(i), "Measurement: vout") <> 0 Then
        For j = 0 To numberOfSteps - 1
            Cells(Row, Column) = Val(Mid(errorLogFile(i + j + 2), 8, 7))
            Row = Row + 1
        Next j
    End If
Next i

'Populate Gain Column
Row = 6
Column = 3
For i = 0 To lineCounter - 1
    If InStr(errorLogFile(i), "Measurement: gain") <> 0 Then
        For j = 0 To numberOfSteps - 1
            Cells(Row, Column) = 20 * Log10(Val(Mid(errorLogFile(i + j + 2), 8, 7)))
            Row = Row + 1
        Next j
    End If
Next i

'Populate Power Column
Row = 6
Column = 4
For i = 0 To lineCounter - 1
    If InStr(errorLogFile(i), "Measurement: rms_power") <> 0 Then
        For j = 0 To numberOfSteps - 1
            Cells(Row, Column) = Val(Mid(errorLogFile(i + j + 2), 8, 9))
            Row = Row + 1
        Next j
    End If
Next i

End Sub

Private Static Function Log10(x)
    Log10 = Log(x) / Log(10#)
End Function

Public Function NumericOnly(s As String) As String
      Static re As VBScript_RegExp_55.RegExp
      If re Is Nothing Then
        Set re = New RegExp
        re.IgnoreCase = True: re.Global = True
        re.Pattern = "-?\d*\.?\d+"
       End If

      If re.test(s) Then
          NumericOnly = re.Execute(s)(0)
          If Left(NumericOnly, 1) = "." Then NumericOnly = "0" & NumericOnly ' <-- to add leading 0 if necessary
          If Left(NumericOnly, 2) = "-." Then NumericOnly = "-0." & Mid(NumericOnly, 3) ' <-- to add leading 0 if necessary
      End If
  End Function
